/**
 * Created by Kevin Kreps on 29.12.2015.
 *
 * @author Kevin Kreps
 * @copyright Kevin Kreps
 */

function Schneeflocke() {
    var Flockenbehälter = document.getElementById("Flockenbehälter");
    var xPos = Math.random() * document.body.offsetWidth;
    var yPos = -100;
    var speed = Math.random() * 5 + 10;
    var size = Math.random() * 10 + 7;
    var Flocke = document.createElement('div');
    Flocke.style.fontSize = size + "px";
    Flocke.style.left = xPos + "px";
    Flocke.innerHTML = "•";
    Flocke.setAttribute('id', 'Schneeflocke');
    Flockenbehälter.appendChild(Flocke);

    falling();

    function falling() {
        if (isActive) {
            yPos += 3;
            Flocke.style.top = yPos + "px";

            xPos += xMovement;
            Flocke.style.left = xPos + "px";
            if (xPos < -8) {
                xPos = Flockenbehälter.offsetWidth;
            } else if (xPos > Flockenbehälter.offsetWidth) {
                xPos = -7;
            }
        }

        if (yPos + 8 > window.innerHeight) {
            deleteThis();
        } else if (xMouse - 10 < xPos && xPos < xMouse + 10 && yMouse - 10 < yPos && yPos < yMouse + 10) {
            console.log("Gefangen");
            deleteThis();
        } else {
            setTimeout(falling, speed);
        }
    }

    function deleteThis() {
        Flockenbehälter.removeChild(Flocke);
    }
}

var xMovement = 0;
var xMouse = 0;
var yMouse = 0;
window.document.onmousemove = function (event) {
    xMovement = (event.x - (document.body.offsetWidth / 2)) / 200;
    xMouse = event.x;
    yMouse = event.y;
};

var isActive = true;
window.onfocus = function () {
    isActive = true;
};
window.onblur = function () {
    isActive = false;
};

function startSchneefall() {
    var Flockenbehälter = document.createElement('div');
    Flockenbehälter.setAttribute('id', 'Flockenbehälter');
    document.body.appendChild(Flockenbehälter);

    SchneewellenSchleife();
}

function SchneewellenSchleife() {

    if (isActive) {
        new Schneeflocke();
        new Schneeflocke();
        new Schneeflocke();
        new Schneeflocke();
    }

    setTimeout(SchneewellenSchleife, 1000);
}